﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = GenerateData().Tables[0].DefaultView;
        }
        
        private DataSet GenerateData()
        {
            var data = new DataSet("SimpleData");
            data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");

            parent.Columns.Add("ID", typeof(int));
            parent.Columns.Add("Name", typeof(string));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("ID", typeof(int));
            children.Columns.Add("Child", typeof(string));
            children.Columns.Add("Count", typeof(int));
            children.Columns.Add("Parent_ID", typeof(int));

            children.PrimaryKey = new[] { children.Columns[0] };

            DataTable children1 = new DataTable("Children1");

            children1.Columns.Add("ID", typeof(int));
            children1.Columns.Add("Child", typeof(string));
            children1.Columns.Add("Age", typeof(int));
            children1.Columns.Add("Parent_ID", typeof(int));

            children1.PrimaryKey = new[] { children1.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);
            data.Tables.Add(children1);


            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[3], false);
            data.Relations.Add("Parent_Child1", parent.Columns[0], children1.Columns[3], false);

            for (int i = 1; i < 4; i++)
            {

                data.Tables["Parent"].Rows.Add(new object[] { i, "Parent" + i });
                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] { j, "Child" + j, j + i, i });
                    data.Tables["Children1"].Rows.Add(new object[] { j, "Child_1" + j, j + i, i });
                }
            }

            data.AcceptChanges();

            return data;
        } 				
    }				
}
